Description

In adding Smart Parameters to some classes for saz\sudo I found an interesting, and error causing, behaviors.

1. When entering into a smart parameter for a string it shows the double quotes in the string

"# Comment

Cmnd_Alias SOMERULE = /bin/false

testuser ALL NOPASSWD: SOMERULE"

If this is overriden to be

_"# Comment

Cmnd_Alias SOMERULE = /bin/false

testuser ALL NOPASSWD: SOMERULE

1. Another Comment"_

The puppet run fails with syntax error messages for the lines where the smart parameter was overridden. A puppet catalog run

against the host on the master shows:

"mysmartvar": "\"# Comment\r\nCmnd_Alias SOMERULE = /bin/false\r\ntestuser ALL NOPASSWD: SOMERULE\r\n# Another

Comment*\"*\r\n"

This of course isn't valid syntax for sudoers which wants

1. Comment

Cmnd_Alias SOMERULE = /bin/false

testusers ALL NOPASSWD: SOMERULE

2. Another Comment

IF the comments are taken off, the rule is passed mostly correctly. Unfortunately that leads to second issue.

2. Smart Parameter Strings had \r\n appended to end of line instead of only \n.

Continuing with the above example:

When the smart parameter isn't overridden the parameter in the catalog is:

"mysmartvar": "# Comment\nCmnd_Alias SOMERULE = /bin/false\ntestuser ALL NOPASSWD: SOMERULE\n# Another

Comment\n"

Just clicking override and removing the quotes, to work around #1 above, the string sent to the host becomes:

"mysmartvar": "# Comment\r\nCmnd_Alias SOMERULE = /bin/false\r\ntestuser ALL NOPASSWD: SOMERULE\r\n# Another

Comment\r\n"

This results in the sudoers line become Windows/Dos formatted:

_# Comment*^M*
Cmnd_Alias SOMERULE = /bin/false*^M*

testuser ALL NOPASSWD: SOMERULE*$M*

1. Another Comment*^M*

_

To ensure this was not a browser / OS issue. I used Firefox from my Linux Master and Chrome from my Windows desktop. The ^M

was added in both cases.

As a workaround I modified the sudo::conf.pp file block from content => $content_real, to content => dos2unix($content_real),.

Unfortunately that modification may not be viable for all Puppet versions / configurations.

Related issues:

Related to Foreman - Bug #8997: ^M in multi line parameter New 01/16/2015

History

#1 - 05/08/2017 03:12 AM - Dominic Cleal

- Related to Bug #8997: ^M in multi line parameter added

#2 - 02/27/2021 11:52 AM - Amalia Bentley

Strings can present strange errors. While I WRITE MY ESSAY I try not to use strings as they can sometimes present errors that should not exist. It's

better to find alternatives like a char array.

#3 - 08/06/2021 11:36 AM - Leos Stejskal

- Triaged changed from No to Yes

#4 - 04/23/2022 04:21 PM - Usa Esasy

I almost completed my dissertation on time, everything was going smoothly and according to the plan but then

I had major personal problems and couldn’t finish editing. I sent my papers to

essayhub review essayhub review</a> service and they completed it splendidly.

These guys are rescued me and i will recommend this company to all my colleagues!

#5 - 06/03/2022 12:31 PM - karl lager

Great post! Was interested to read it! Yet I have smth to recommend you as an editor.

It is not easy to find an essay writing service these days. There are so many platforms

that promise superb quality,

fast turnaround, and adherence to your needs yet prove to be unreliable in the long run.

So, take your time to read and to browse the web and to pick a service like custom essay writing company

you really trust and can rely on.

#6 - 06/17/2022 01:05 PM - stefan sterners

Great post! Was interested to read it! Yet I have smth to recommend you as an editor.

It is not easy to find an essay writing service these days. There are so many platforms

that promise superb quality,

fast turnaround, and adherence to your needs yet prove to be unreliable in the long run.

So, take your time to read and to browse the web and to pick a service like help with writing papers

you really trust and can rely on.

#7 - 07/14/2022 05:02 PM - kevin brow

I almost completed my dissertation on time, everything was going smoothly and according to the plan but then

I had major personal problems and couldn’t finish editing. I sent my papers to

college essay services     service and they completed it splendidly.

These guys are rescued me and i will recommend this company to all my colleagues!
